// FCEdit.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "stdafx.h"
#include "flashquiz.h"
#include "FlashCard.h"
#include "FCEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFlashQuizApp theApp;
extern CFlashQuizDoc theDoc;

/////////////////////////////////////////////////////////////////////////////
// CFCEdit dialog


CFCEdit::CFCEdit(CWnd* pParent /*=NULL*/)
	: CDialog(CFCEdit::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFCEdit)
	m_bUseBitmap = FALSE;
	m_bReduce = FALSE;
	m_bTimeLimit = FALSE;
	m_strBitmap = _T("");
	m_strQuestion = _T("");
	m_strAnswer = _T("");
	m_intReduceScore = 1;
	m_intReduceTime = 1;
	m_intScore = 1;
	m_intTimeLimit = 1;
	m_bCustomFont = FALSE;
	//}}AFX_DATA_INIT
}


void CFCEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFCEdit)
	DDX_Control(pDX, IDC_cmdFont, m_cmdFont);
	DDX_Control(pDX, IDOK, m_cmdOK);
	DDX_Control(pDX, IDCANCEL, m_cmdCancel);
	DDX_Control(pDX, IDC_txtTimeLimit, m_txtTimeLimit);
	DDX_Control(pDX, IDC_txtReduceTime, m_txtReduceTime);
	DDX_Control(pDX, IDC_txtReduceScore, m_txtReduceScore);
	DDX_Control(pDX, IDC_txtAnswer1, m_txtAnswer);
	DDX_Control(pDX, IDC_txtQuestion, m_txtQuestion);
	DDX_Control(pDX, IDC_txtBitmap, m_txtBitmap);
	DDX_Control(pDX, IDC_spnTime, m_spnTime);
	DDX_Control(pDX, IDC_spnScore, m_spnScore);
	DDX_Control(pDX, IDC_spnReduceTime, m_spnReduceTime);
	DDX_Control(pDX, IDC_spnReduceScore, m_spnReduceScore);
	DDX_Control(pDX, IDC_cmdBrowse, m_cmdBrowse);
	DDX_Control(pDX, IDC_chkTimeLimit, m_chkTimeLimit);
	DDX_Control(pDX, IDC_chkReduce, m_chkReduce);
	DDX_Control(pDX, IDC_chkBitmap, m_chkBitmap);
	DDX_Check(pDX, IDC_chkBitmap, m_bUseBitmap);
	DDX_Check(pDX, IDC_chkReduce, m_bReduce);
	DDX_Check(pDX, IDC_chkTimeLimit, m_bTimeLimit);
	DDX_Text(pDX, IDC_txtBitmap, m_strBitmap);
	DDX_Text(pDX, IDC_txtQuestion, m_strQuestion);
	DDX_Text(pDX, IDC_txtAnswer1, m_strAnswer);
	DDX_Text(pDX, IDC_txtReduceScore, m_intReduceScore);
	DDX_Text(pDX, IDC_txtReduceTime, m_intReduceTime);
	DDX_Text(pDX, IDC_txtScore, m_intScore);
	DDX_Text(pDX, IDC_txtTimeLimit, m_intTimeLimit);
	DDX_Check(pDX, IDC_chkCustomFont, m_bCustomFont);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFCEdit, CDialog)
	//{{AFX_MSG_MAP(CFCEdit)
	ON_BN_CLICKED(IDC_chkBitmap, OnchkBitmap)
	ON_BN_CLICKED(IDC_chkReduce, OnchkReduce)
	ON_BN_CLICKED(IDC_chkTimeLimit, OnchkTimeLimit)
	ON_BN_CLICKED(IDC_cmdBrowse, OncmdBrowse)
	ON_BN_CLICKED(IDC_cmdPreview, OncmdPreview)
	ON_BN_CLICKED(IDC_cmdFont, OncmdFont)
	ON_EN_CHANGE(IDC_txtQuestion, OnChangetxtQuestion)
	ON_EN_CHANGE(IDC_txtBitmap, OnChangetxtBitmap)
	ON_BN_CLICKED(IDC_chkCustomFont, OnchkCustomFont)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFCEdit message handlers

BOOL CFCEdit::OnInitDialog() 
{
	CString strTemp;
	CFont* pFont;

	CDialog::OnInitDialog();
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	m_txtQuestion.SetLimitText(255);
	m_txtAnswer.SetLimitText(128);
	m_spnTime.SetRange(1, 300);
	m_spnScore.SetRange(1, 50);
	m_spnReduceScore.SetRange(1, 10);
	m_spnReduceTime.SetRange(1, 300);
	m_bFontChanged = FALSE;
	if (m_bMode)
	{
		if (m_pQuestion != NULL)
		{
			m_strAnswer = m_pQuestion->m_strAnswers[0];
			m_strQuestion = m_pQuestion->m_strQuestion;
			m_chkBitmap.SetCheck(!m_pQuestion->m_strBitmapFile.IsEmpty());
			m_strBitmap = m_pQuestion->m_strBitmapFile;
			m_bUseBitmap = !m_strBitmap.IsEmpty();
			m_intScore = m_pQuestion->m_intScore;
			m_spnScore.SetPos(m_intScore);
		}
		strTemp.Format("Editing Flash Card %u", m_intItem);
		SetWindowText(strTemp);
	}
	else
	{
		strTemp.Format("Adding Flash Card %u", m_intItem);
		SetWindowText(strTemp);
		m_pQuestion = new CQuestion;
		if (m_pQuestion == NULL)
		{
			::MessageBox(NULL, "CQuestion allocation failed", "QEdit error", MB_ICONINFORMATION);
			EndDialog(IDCANCEL);
		}
		m_pQuestion->m_intScore = theDoc.m_intDefaultScore;
		m_pQuestion->m_intTime = theDoc.m_intDefaultQuestionTime;
		m_pQuestion->m_intTimeDeduct = theDoc.m_intDefaultTimeDeduct;
		m_pQuestion->m_intScoreDeduct = theDoc.m_intDefaultScoreDeduct;
		if (theDoc.m_bCustomFont)
			m_pQuestion->Set_Font(&theDoc.m_fontCustom);
		m_strAnswer.Empty();
		m_strQuestion.Empty();
		m_strBitmap.Empty();
		m_bUseBitmap = FALSE;
		m_cmdOK.SetWindowText("Add Flash Card");
		m_cmdOK.EnableWindow(FALSE);
		m_cmdCancel.SetWindowText("Done");
	}
	if (m_pQuestion->m_intTime == 0)
	{
		m_intTimeLimit = 1;
		m_bTimeLimit = FALSE;
	}
	else
	{
		m_intTimeLimit = m_pQuestion->m_intTime;
		m_bTimeLimit = TRUE;
	}
	m_spnTime.SetPos(m_intTimeLimit);
	if (m_pQuestion->m_intTimeDeduct == 0)
	{
		m_intReduceTime = 1;
		m_intReduceScore = 1;
		m_bReduce = FALSE;
	}
	else
	{
		m_intReduceTime = m_pQuestion->m_intTimeDeduct;
		m_intReduceScore = m_pQuestion->m_intScoreDeduct;
		m_bReduce = TRUE;
	}
	m_intScore = m_pQuestion->m_intScore;
	m_spnScore.SetPos(m_intScore);
	m_bCustomFont = m_pQuestion->m_bCustomFont;
	m_cmdFont.EnableWindow(m_bCustomFont);
	if (m_bCustomFont)
	{
		m_fontCustom = *m_pQuestion->m_pFont;
	}
	else
	{
		pFont = GetFont();
		pFont->GetLogFont(&m_fontCustom);
	}
	m_spnReduceTime.SetPos(m_intReduceTime);
	m_spnReduceScore.SetPos(m_intReduceScore);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	UpdateData(FALSE);
	Enable_Numerics();
	return TRUE;
}

///////////////////////////////////
// Control handlers.

void CFCEdit::OnCancel() 
{
	if (!m_bMode)
	{
		UpdateData(TRUE);
		if (Fields_Changed())
		{
			if (MessageBox("Quit without adding this flash card?", "FlashQuiz", MB_YESNO | MB_ICONQUESTION) != IDYES)
				return;
		}
		if (m_pQuestion != NULL)
		{
			delete m_pQuestion;
			m_pQuestion = NULL;
		}
	}
	CDialog::OnCancel();
}

void CFCEdit::OnchkBitmap() 
{
	UpdateData(TRUE);
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	if (m_bUseBitmap)
		m_txtBitmap.SetFocus();
	Enable_Add_Button();
}

void CFCEdit::OnchkReduce() 
{
	Enable_Numerics();
}

void CFCEdit::OnchkTimeLimit() 
{
	Enable_Numerics();
}

// Browse for an image file.
void CFCEdit::OncmdBrowse() 
{
	CString strTemp;
	char	szBuffer[_MAX_PATH];

	GetCurrentDirectory(_MAX_PATH, szBuffer);
	CFileDialog dlg(TRUE, ".bmp", NULL, OFN_EXPLORER | OFN_FILEMUSTEXIST, "Windows Bitmaps (*.bmp)|*.bmp||", this);
	if (dlg.DoModal() == IDOK)
	{
		strTemp = dlg.GetPathName();
		m_txtBitmap.SetWindowText(strTemp);
	}
	else
	{
		UpdateData(TRUE);
		if (m_strBitmap.IsEmpty())
		{
			m_bUseBitmap = FALSE;
			m_txtBitmap.EnableWindow(FALSE);
			m_cmdBrowse.EnableWindow(FALSE);
			m_chkBitmap.SetCheck(0);
		}
	}
	SetCurrentDirectory(szBuffer);
}

// Preview the current question.
void CFCEdit::OncmdPreview() 
{
	CFlashCard	dlg;
	CQuestion	question;

	if (!Validate_Fields())
		return;
	theDoc.m_intTimeLeft = theDoc.m_intTimeLimit * 60;
	theDoc.m_intPossibleScore = 0;
	theDoc.m_intTotalScore = 0;
	question.m_strQuestion = m_strQuestion;
	question.m_strAnswers[0] = m_strAnswer;
	question.m_intScore = m_intScore;
	if (m_bCustomFont)
		question.Set_Font(&m_fontCustom);
	if (m_bTimeLimit)
		question.m_intTime = m_intTimeLimit;
	else
		question.m_intTime = 0;
	if (m_bTimeLimit && m_bReduce)
	{
		question.m_intScoreDeduct = m_intReduceScore;
		question.m_intTimeDeduct = m_intReduceTime;
	}
	else
	{
		question.m_intScoreDeduct = 0;
		question.m_intTimeDeduct = 0;
	}
	if (m_bUseBitmap)
		question.m_strBitmapFile = m_strBitmap;
	else
		question.m_strBitmapFile.Empty();
	dlg.m_pQuestion = &question;
	dlg.m_intQuestion = m_intItem;
	dlg.m_bPreviewMode = TRUE;
	dlg.DoModal();
}

void CFCEdit::OnOK() 
{
	if (!Validate_Fields())
		return;
	if (Fields_Changed())
		theDoc.SetModifiedFlag(TRUE);
	m_pQuestion->m_strQuestion = m_strQuestion;
	m_pQuestion->m_strAnswers[0] = m_strAnswer;
	m_pQuestion->m_intScore = m_intScore;
	if (m_bTimeLimit)
		m_pQuestion->m_intTime = m_intTimeLimit;
	else
		m_pQuestion->m_intTime = 0;
	if (m_bTimeLimit && m_bReduce)
	{
		m_pQuestion->m_intScoreDeduct = m_intReduceScore;
		m_pQuestion->m_intTimeDeduct = m_intReduceTime;
	}
	else
	{
		m_pQuestion->m_intScoreDeduct = 0;
		m_pQuestion->m_intTimeDeduct = 0;
	}
	if (m_bUseBitmap)
		m_pQuestion->m_strBitmapFile = m_strBitmap;
	else
		m_pQuestion->m_strBitmapFile.Empty();
	if (m_bCustomFont)
		m_pQuestion->Set_Font(&m_fontCustom);
	else
		m_pQuestion->Set_Font(NULL);
	CDialog::OnOK();
}

void CFCEdit::OncmdFont() 
{
	Do_Choose_Font();
}

void CFCEdit::OnChangetxtQuestion() 
{
	Enable_Add_Button();
}

void CFCEdit::OnChangetxtBitmap() 
{
	Enable_Add_Button();
}

void CFCEdit::OnchkCustomFont() 
{
	UpdateData(TRUE);	// Retrieve the setting.
	if (m_bCustomFont)		// If box was just checked,
	{
		if (Do_Choose_Font() != IDOK)	// Let the user choose the custom font.
		{
			m_bCustomFont = FALSE;			// If he canceled, clear the checkbox.
			UpdateData(FALSE);
		}
	}
	m_cmdFont.EnableWindow(m_bCustomFont);
}

//////////////////////////////////////////
// Helper functions.

// Compares current settings with initial settings.
// Returns TRUE if any settings have changed.
BOOL CFCEdit::Fields_Changed()
{
	int		i;
	BYTE	*p1,
			*p2;

	if (m_strQuestion != m_pQuestion->m_strQuestion)
		return TRUE;
	if (m_bUseBitmap != (!m_pQuestion->m_strBitmapFile.IsEmpty()))
		return TRUE;
	if (m_bUseBitmap)
		if (m_strBitmap != m_pQuestion->m_strBitmapFile)
			return TRUE;
	if (m_strAnswer != m_pQuestion->m_strAnswers[0])
		return TRUE;
	if ((int) m_intScore != m_pQuestion->m_intScore)
		return TRUE;
	if (m_bTimeLimit != (m_pQuestion->m_intTime != 0))
		return TRUE;
	if (m_bTimeLimit)
		if ((int) m_intTimeLimit != m_pQuestion->m_intTime)
			return TRUE;
	if (m_bReduce != (m_pQuestion->m_intTimeDeduct != 0))
		return TRUE;
	if (m_bReduce)
	{
		if ((int) m_intReduceScore != m_pQuestion->m_intScoreDeduct)
			return TRUE;
		if ((int) m_intReduceTime != m_pQuestion->m_intTimeDeduct)
			return TRUE;
	}
	if (m_bCustomFont != m_pQuestion->m_bCustomFont)
		return TRUE;
	if (m_bCustomFont)
	{
		p1 = (BYTE *) &m_fontCustom;
		p2 = (BYTE *) m_pQuestion->m_pFont;
		for (i = 0; i < sizeof(LOGFONT); i ++)
		{
			if (p1[i] != p2[i])
				return TRUE;
		}
	}
	return FALSE;
}

// Enables/disables the scoring/timing fields.
void CFCEdit::Enable_Numerics()
{
	UpdateData(TRUE);
	BOOL bEnable = m_bTimeLimit;
	m_txtTimeLimit.EnableWindow(bEnable);
	m_spnTime.EnableWindow(bEnable);
	m_chkReduce.EnableWindow(bEnable);
	bEnable = m_bTimeLimit && m_bReduce;
	m_txtReduceTime.EnableWindow(bEnable);
	m_spnReduceTime.EnableWindow(bEnable);
	m_txtReduceScore.EnableWindow(bEnable);
	m_spnReduceScore.EnableWindow(bEnable);
}

void CFCEdit::Enable_Add_Button()
{
	if (m_bMode)
		return;
	UpdateData(TRUE);
	m_cmdOK.EnableWindow(!m_strQuestion.IsEmpty() || (m_bUseBitmap && !m_strBitmap.IsEmpty()));
}

int CFCEdit::Do_Choose_Font()
{
	int			iResult;
	CFontDialog* pDlg;		// Create a common Font dialog object.
	LOGFONT		font;
	
	// Create font dialog with current font data.
	pDlg = new CFontDialog(&m_fontCustom);
	iResult = pDlg->DoModal();
	if (iResult == IDOK)
	{
		// Retrieve current font information.
		pDlg->GetCurrentFont(&font);
		// Copy to local storage.
		m_fontCustom = font;
	}
	delete pDlg;
	return iResult;
}

// Ensures that required input is present, and that
// image file field is valid.
// Called by OnOK()
BOOL CFCEdit::Validate_Fields()
{
	CString strTemp, strTemp2;
	BOOL	bResult;

	UpdateData(TRUE);
	m_strQuestion.TrimLeft();
	m_strQuestion.TrimRight();
	if (m_bUseBitmap)
	{
		if (theApp.Find_Image_File(m_strBitmap, strTemp))
		{
			bResult = theApp.Check_Bitmap_Header(strTemp);
			if (!bResult)
			{
				strTemp2.Format("%s is not a valid Windows bitmap.", strTemp);
				MessageBox(strTemp2, "FlashQuiz", MB_ICONINFORMATION);
			}
			return bResult;
		}
		else
		{
			MessageBox("Bitmap file does not exist, either in\n"
						"the specified directory or the current working directory.", "FlashQuiz", MB_ICONINFORMATION);
			return FALSE;
		}
	}
	else
	{
		if (m_strQuestion.IsEmpty())
		{
			MessageBox("Flash cards must have question text or an image file.", "FlashQuiz", MB_ICONINFORMATION);
			return FALSE;
		}
	}
	return TRUE;
}