// FlashQuizDoc.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "stdafx.h"
#include "FlashQuiz.h"
#include "FlashQuizDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFlashQuizApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFlashQuizDoc

// Don't need this since we're not using document/view architecture.
//IMPLEMENT_DYNCREATE(CFlashQuizDoc, CDocument)

CFlashQuizDoc::CFlashQuizDoc()
{
	int i;

	for (i = 0; i < 512; i++)
		m_pQuestionArray[i] = NULL;
	m_intQuestionCount = 0;
	m_strFileName.Empty();
	m_strPassword.Empty();
	m_bLog = m_bTimeLimit = FALSE;
	m_intQuizType = 0;
	m_intTimeLimit = 0;
	m_intDefaultScore = 1;
	m_intDefaultQuestionTime = 0;
	m_intDefaultTimeDeduct = 0;
	m_intDefaultScoreDeduct = 1;
	m_bShowCorrect = TRUE;
	m_bCustomFont = FALSE;
}

BOOL CFlashQuizDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

CFlashQuizDoc::~CFlashQuizDoc()
{
	DeleteContents();
}


BEGIN_MESSAGE_MAP(CFlashQuizDoc, CDocument)
	//{{AFX_MSG_MAP(CFlashQuizDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFlashQuizDoc diagnostics

#ifdef _DEBUG
void CFlashQuizDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFlashQuizDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFlashQuizDoc serialization

void CFlashQuizDoc::Serialize(CArchive& ar)
{
	int			i, j, iDataLen, iCount;
	BOOL		bDummy = FALSE;
	int			iDummy = 0;
	BYTE		*pData;
	LOGFONT		font;
	CString		strTemp;
	CQuestion	*pQuestion = NULL;

	if (ar.IsStoring())
	{
		strTemp = "FlashQuiz 1.2";
		ar << strTemp;
		pData = theApp.Scramble(m_strPassword);
		iDataLen = m_strPassword.GetLength();
		Write_String(ar, pData, iDataLen);
		ar << m_intQuizType;
		ar << m_bTimeLimit;
		ar << m_intTimeLimit;
		ar << m_bLog;
		ar << m_bShowCorrect;
		ar << m_intQuestionCount;
		ar << m_bRandomA;
		ar << m_bRandomQ;
		for (i = 0; i < m_intQuestionCount; i++)
		{
			pQuestion = m_pQuestionArray[i];
			pData = theApp.Scramble(pQuestion->m_strQuestion);
			iDataLen = pQuestion->m_strQuestion.GetLength();
			Write_String(ar, pData, iDataLen);
			pData = theApp.Scramble(pQuestion->m_strBitmapFile);
			iDataLen = pQuestion->m_strBitmapFile.GetLength();
			Write_String(ar, pData, iDataLen);
			ar << pQuestion->m_intScore;
			ar << pQuestion->m_intScoreDeduct;
			ar << pQuestion->m_intTime;
			ar << pQuestion->m_intTimeDeduct;
			ar << pQuestion->m_bAllowMultiple;
			ar << pQuestion->m_bCustomFont;
			for (j = 0; j < 5; j++)
			{
				pData = theApp.Scramble(pQuestion->m_strAnswers[j]);
				iDataLen = pQuestion->m_strAnswers[j].GetLength();
				Write_String(ar, pData, iDataLen);
				ar << pQuestion->m_bCorrect[j];
			}
			if (pQuestion->m_bCustomFont)
			{
				iDataLen = sizeof(LOGFONT);
				pData = new BYTE[iDataLen];
				memcpy(pData, pQuestion->m_pFont, iDataLen);
				Write_String(ar, pData, iDataLen);
			}
		}
		ar << m_bCustomFont;
		ar << m_intDefaultScore;
		ar << m_intDefaultQuestionTime;
		ar << m_intDefaultTimeDeduct;
		ar << m_intDefaultScoreDeduct;
		if (m_bCustomFont)
		{
			iDataLen = sizeof(LOGFONT);
			pData = new BYTE[iDataLen];
			memcpy(pData, &m_fontCustom, iDataLen);
			Write_String(ar, pData, iDataLen);
		}
		SetModifiedFlag(FALSE);
	}
	else
	{
		pQuestion = NULL;
		m_bLoadFail = FALSE;
		try
		{
			ar >> strTemp;
		}
		catch (CException *e)
		{
			e->Delete();
			m_bLoadFail = TRUE;
			return;
		}
		if (strTemp != "FlashQuiz 1.2")
		{
			m_bLoadFail = TRUE;
			return;
		}
		if ((m_bLoadFail = !Read_String(ar, strTemp)))
			return;
		else
			m_strPassword = strTemp;
		try 
		{
			ar >> m_intQuizType;
			ar >> m_bTimeLimit;
			ar >> m_intTimeLimit;
			ar >> m_bLog;
			ar >> m_bShowCorrect;
			ar >> iCount;
			ar >> m_bRandomA;
			ar >> m_bRandomQ;
		}
		catch (CException *e)
		{
			e->Delete();
			m_bLoadFail = TRUE;
			DeleteContents();
			return;
		}
		for (i = 0; i < iCount; i++)
		{
			pQuestion = new CQuestion;
			if (pQuestion == NULL)
			{
				m_bLoadFail = TRUE;
				return;
			}
			if ((m_bLoadFail = !Read_String(ar, strTemp)))
			{
				delete pQuestion;
				return;
			}
			else
			{
				pQuestion->m_strQuestion = strTemp;
			}
			if ((m_bLoadFail = !Read_String(ar, strTemp)))
			{
				delete pQuestion;
				return;
			}
			else
			{
				pQuestion->m_strBitmapFile = strTemp;
			}
			try
			{
				ar >> pQuestion->m_intScore;
				ar >> pQuestion->m_intScoreDeduct;
				ar >> pQuestion->m_intTime;
				ar >> pQuestion->m_intTimeDeduct;
				ar >> pQuestion->m_bAllowMultiple;
				ar >> pQuestion->m_bCustomFont;
			}
			catch (CException *e)
			{
				e->Delete();
				m_bLoadFail = TRUE;
				delete pQuestion;
				DeleteContents();
				return;
			}
			for (j = 0; j < 5; j ++)
			{
				if ((m_bLoadFail = !Read_String(ar, strTemp)))
				{
					delete pQuestion;
					return;
				}
				else
					pQuestion->m_strAnswers[j] = strTemp;
				try
				{
					ar >> pQuestion->m_bCorrect[j];
				}
				catch (CException *e)
				{
					e->Delete();
					delete pQuestion;
					m_bLoadFail = TRUE;
					DeleteContents();
					return;
				}
			}
			if (pQuestion->m_bCustomFont)
			{
				ar >> iDataLen;
				if (iDataLen != sizeof(LOGFONT))
				{
					delete pQuestion;
					m_bLoadFail = TRUE;
					DeleteContents();
					return;
				}
				pData = (BYTE *) &font;
				try
				{
					for (j = 0; j < iDataLen; j++)
					{
						ar >> pData[j];
					}
				}
				catch (CException *e)
				{
					e->Delete();
					delete pQuestion;
					m_bLoadFail = TRUE;
					DeleteContents();
					return;
				}
				pQuestion->Set_Font(&font);
			}
			Add_Question(pQuestion);
			pQuestion = NULL;
		}
		try
		{
			ar >> m_bCustomFont;
			ar >> m_intDefaultScore;
			ar >> m_intDefaultQuestionTime;
			ar >> m_intDefaultTimeDeduct;
			ar >> m_intDefaultScoreDeduct;
		}
		catch (CException *e)
		{
			e->Delete();
			m_bLoadFail = TRUE;
			delete pQuestion;
			DeleteContents();
			return;
		}
		if (m_bCustomFont)
		{
			ar >> iDataLen;
			if (iDataLen != sizeof(LOGFONT))
			{
				delete pQuestion;
				m_bLoadFail = TRUE;
				DeleteContents();
				return;
			}
			pData = (BYTE *) &m_fontCustom;
			try
			{
				for (j = 0; j < iDataLen; j++)
				{
					ar >> pData[j];
				}
			}
			catch (CException *e)
			{
				e->Delete();
				delete pQuestion;
				m_bLoadFail = TRUE;
				DeleteContents();
				return;
			}
		}
		SetModifiedFlag(FALSE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFlashQuizDoc commands


// Resets the document to empty.
void CFlashQuizDoc::DeleteContents() 
{
	int i;

	for (i = 0; i < m_intQuestionCount; i++)
	{
		if (m_pQuestionArray[i] != NULL)
		{
			delete m_pQuestionArray[i];
			m_pQuestionArray[i] = NULL;
		}
	}
	m_intQuestionCount = 0;
	m_strPassword.Empty();
	m_strFileName.Empty();
	m_intQuizType = 0;
	m_bLog = m_bTimeLimit = FALSE;
	m_bRandomA = m_bRandomQ = FALSE;
	m_bCustomFont = FALSE;
	m_intTimeLimit = 0;
	SetModifiedFlag(FALSE);
}

// Appends a question to the end of the array.
// Returns the index of the new array element.
int CFlashQuizDoc::Add_Question(CQuestion *pQuestion)
{
	int iReturn;

	if (m_intQuestionCount >= 512)
		return -1;
	m_pQuestionArray[m_intQuestionCount] = pQuestion;
	iReturn = m_intQuestionCount;
	++m_intQuestionCount;
	SetModifiedFlag();
	return iReturn;
}

// Returns a pointer to the desired question.
// Returns NULL if specified index is out of range.
CQuestion * CFlashQuizDoc::Get_Question(int iQuestion)
{
	if (iQuestion < 0 || iQuestion >= m_intQuestionCount)
		return NULL;
	return m_pQuestionArray[iQuestion];
}

// Deletes the specified question from the array
// and compacts the array.
void CFlashQuizDoc::Delete_Question(int iIndex)
{
	int i;

	if (iIndex < 0 || iIndex >= m_intQuestionCount)
		return;
	if (m_pQuestionArray[iIndex] != NULL)
	{
		delete m_pQuestionArray[iIndex];
		m_pQuestionArray[iIndex] = NULL;
	}
	--m_intQuestionCount;
	for (i = iIndex; i < m_intQuestionCount; i++)
		m_pQuestionArray[i] = m_pQuestionArray[i + 1];
	m_pQuestionArray[m_intQuestionCount] = NULL;
	SetModifiedFlag();
}

// Inserts a question into the array at the specified position.
BOOL CFlashQuizDoc::Insert_Question(int iPos, CQuestion *pNewQuestion)
{
	int i;

	if (m_intQuestionCount == 512)
		return FALSE;
	if (iPos < 0 || iPos >= 512)
		return FALSE;
	for (i = m_intQuestionCount; i > iPos; i--)
		m_pQuestionArray[i] = m_pQuestionArray[i-1];
	m_pQuestionArray[iPos] = pNewQuestion;
	++m_intQuestionCount;
	SetModifiedFlag();
	return TRUE;
}

// Writes the specified number of bytes from the buffer specified by *pData
// to the specified CArchive, then deletes the buffer.
// Returns TRUE if successful, FALSE if not.
// Note: Buffer pointed to by *pData is _always_ deleted, whether or not
// the write succeeds.
BOOL CFlashQuizDoc::Write_String(CArchive &ar, BYTE *pData, int iLen)
{
	int i;

	// Write data length.
	try
	{
		ar << iLen;
	}
	catch (CException *e)
	{
		e->Delete();
		delete pData;
		return FALSE;
	}
	// Write data.
	try
	{
		for (i = 0; i < iLen; i++)
			ar << pData[i];
	}
	catch (CException *e)
	{
		e->Delete();
		delete pData;
		return FALSE;
	}
	delete pData;	// Delete data buffer.
	return TRUE;	// Indicate success to caller.
}

// Attempts to read and decrypt a string from the specified CArchive.
// Returns TRUE if successful, FALSE if not.
// If function succeeds, the decrypted string will be copied to 
// the CString passed as strData. Otherwise, strData will remain unchanged.
BOOL CFlashQuizDoc::Read_String(CArchive &ar, CString &strData)
{
	int		i, iLen;
	BOOL	bResult;
	BYTE	*pData = NULL;

	// Retrieve length of data.
	try
	{
		ar >> iLen;
	}
	catch (CException *e)
	{
		e->Delete();
		return FALSE;
	}
	if (iLen == 0)			// If length is zero,
	{
		strData.Empty();	// resulting string is empty.
		return TRUE;
	}
	pData = new BYTE[iLen];		// Allocate buffer to hold encrypted string data.
	if (pData == NULL)
		return FALSE;
	// Read data from archive.
	try
	{
		for (i = 0; i < iLen; i++)
			ar >> pData[i];
	}
	catch (CException *e)
	{
		e->Delete();
		delete [] pData;
		return FALSE;
	}
	// Decrypt the data.
	bResult = theApp.UnScramble(pData, iLen, strData);
	// Delete the buffer.
	delete [] pData;
	// Return result to caller.
	return bResult;
}

// Swaps the specified item with the one before or after it,
// based on the bDirection flag.
//  TRUE = move specified item up.
//  FALSE = move specified item down.
BOOL CFlashQuizDoc::Move_Item(BOOL bDirection, int nItem)
{
	CQuestion *pTemp;

	if (m_intQuestionCount <= 1)
		return FALSE;
	if (bDirection)
	{
		if (nItem < 1)
			return FALSE;
		pTemp = m_pQuestionArray[nItem];
		m_pQuestionArray[nItem] = m_pQuestionArray[nItem - 1];
		m_pQuestionArray[nItem - 1] = pTemp;
		SetModifiedFlag(TRUE);
		return TRUE;
	}
	else
	{
		if (nItem == m_intQuestionCount -1)
			return FALSE;
		pTemp = m_pQuestionArray[nItem];
		m_pQuestionArray[nItem] = m_pQuestionArray[nItem + 1];
		m_pQuestionArray[nItem + 1] = pTemp;
		SetModifiedFlag(TRUE);
		return TRUE;
	}
}

int CFlashQuizDoc::Get_Save_Name(CWnd* pParent)
{
	int		iResult;
	LPCTSTR pszSaveName;

	if (m_strFileName.IsEmpty())
		pszSaveName = "Untitled";
	else
		pszSaveName = m_strFileName;
	CFileDialog dlg(FALSE, ".fqz", pszSaveName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, "FlashQuiz Files (*.fqz)|*.fqz||", pParent);
	iResult = dlg.DoModal();
	if (iResult == IDOK)
	{
		Set_File_Name(dlg.GetPathName());
	}
	return iResult;
}

// Saves the current document. If document filename has not been set,
// queries user to get the filename.
BOOL CFlashQuizDoc::Do_Save(CWnd *pParent)
{
	CString		strErr;
	CFile		*pFile = NULL;
	CArchive	*ar = NULL;

	if (m_strFileName.IsEmpty())
	{
		if (Get_Save_Name(pParent) != IDOK)
			return FALSE;
	}
	try
	{
		pFile = new CFile(m_strFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive);
	}
	catch (CFileException* e)
	{
		e->Delete();
		strErr.Format("Could not create or access\n%s", m_strFileName);
		pParent->MessageBox(strErr, "File Save Error", MB_ICONINFORMATION);
		if (pFile != NULL)
			delete pFile;
		return FALSE;
	}
	try
	{
		ar = new CArchive(pFile, CArchive::store);
	}
	catch (CException* e)
	{
		e->Delete();
		pParent->MessageBox("Internal error: CArchive creation failed.", "File Save Error", MB_ICONINFORMATION);
		pFile->Close();
		if (ar != NULL)
			delete ar;
		delete pFile;
		return FALSE;
	}
	Serialize(*ar);
	ar->Close();
	pFile->Close();
	delete ar;
	delete pFile;
	return TRUE;
}

// Prompts user to save the current document if necessary.
// Returns TRUE if:
//       1. Document does not need to be saved.
//       2. Document needs to be saved but user answers "No".
//       3. Document needs to be saved and is saved successfully.
// Returns FALSE if:
//       1. User answers "Cancel" to initial prompt.
//       2. User answers "Yes" to initial prompt but cancels the File Save dialog.
//       3. User answers "Yes" and chooses a target file but the save operation fails.
BOOL CFlashQuizDoc::Do_Query_Save(CWnd* pParent)
{
	int			iResult;

	if (IsModified() && m_intQuestionCount != 0)
	{
		iResult = pParent->MessageBox("Save the current quiz?", "FlashQuiz", MB_ICONQUESTION | MB_YESNOCANCEL);
		switch (iResult)
		{
		case IDCANCEL:
			return FALSE;
		case IDNO:
			return TRUE;
		case IDYES:
			return Do_Save(pParent);
		}
	}
	return TRUE;
}


// Resets scores & flags.
void CFlashQuizDoc::Reset_Quiz()
{
	int i, j;
	CQuestion *pQuestion;

	if (m_intQuestionCount <= 0)
		return;
	for (i = 0; i < m_intQuestionCount; i++)
	{
		pQuestion = m_pQuestionArray[i];
		if (pQuestion != NULL)
		{
			pQuestion->m_bPresented = FALSE;
			pQuestion->m_intActualScore = 0;
			pQuestion->m_bTimedOut = FALSE;
			for (j = 0; j < 5; j++)
				pQuestion->m_bAnswers[j] = FALSE;
		}
	}
}

// Appends results of a completed quiz to the score log.
BOOL CFlashQuizDoc::Log_Quiz(LPCTSTR pszComment)
{
	int			i, j;
	int			iMaxScorePresented = 0,
				iMaxScoreAll = 0,
				iScorePresented = 0,
				iScoreAll = 0,
				iPresented = 0;
	BOOL		bAnswered, bStatus;
	CFile		file;
	CString		strLine,
				strTemp;
	CQuestion	*pQuestion;

	if (m_strLogFileName.IsEmpty())
		return FALSE;
	if (!file.Open(m_strLogFileName, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate | CFile::shareDenyWrite, NULL))
		return FALSE;
	file.SeekToEnd();
	if (file.GetPosition() == 0)
		file.Write("FlashQuiz Log", 13);
	strLine.Format("\"%s\"\r\n%u\r\n", pszComment, m_intQuestionCount);
	bStatus = Write_Line(file, strLine);
	strLine.Empty();
	for (i = 0; bStatus && (i < m_intQuestionCount); i++)
	{
		pQuestion = m_pQuestionArray[i];
		strTemp.Format("%u,", i + 1);
		strLine += strTemp;
		iScoreAll += pQuestion->m_intActualScore;
		iMaxScoreAll += pQuestion->m_intScore;
		strTemp.Empty();
		if (pQuestion->m_bPresented)
		{
			++iPresented;
			iScorePresented += pQuestion->m_intActualScore;
			iMaxScorePresented += pQuestion->m_intScore;
			if (m_intQuizType == 0)
			{
				for (j = 0; j < 5; j++)
				{
					if (pQuestion->m_bCorrect[j])
						strTemp += (char) 'A' + j;
				}
				strTemp += ',';
				bAnswered = FALSE;
				for (j = 0; j < 5; j++)
				{
					if (pQuestion->m_bAnswers[j])
					{
						strTemp += (char) 'A' + j;
						bAnswered = TRUE;
					}
				}
				if (!bAnswered)
					strTemp += 'X';
				strLine += strTemp;
				strLine += ',';
				strTemp.Format("%u,%u",
						pQuestion->m_intScore,
						pQuestion->m_intActualScore);
			}
			else
			{
				strTemp.Format("%u,%u,%u,1",
					pQuestion->m_intScore,
					pQuestion->m_intActualScore,
					pQuestion->m_bTimedOut ? 1 : 0);
			}
			strLine += strTemp;
		}
		else
		{
			if (m_intQuizType == 0)
			{
				strTemp.Format("X,X,%u,0", pQuestion->m_intScore);
				strLine += strTemp;
			}
			else
			{
				strTemp.Format("%u,0,0,0", pQuestion->m_intScore);
				strLine += strTemp;
			}
		}
		strLine += "\r\n";
		if (strLine.GetLength() > 2048)
		{
			bStatus = Write_Line(file, strLine);
			strLine.Empty();
		}
	}
	if (bStatus)
	{
		strTemp.Format("Presented,%u,%u,%u,%.2f%%\r\nAll,%u,%u,%u,%.2f%%\r\n",
			iPresented,
			iScorePresented,
			iMaxScorePresented,
			((float) (100 * iScorePresented)) / iMaxScorePresented,
			m_intQuestionCount,
			iScoreAll,
			iMaxScoreAll,
			((float) (100 * iScoreAll)) / iMaxScoreAll);
		strLine += strTemp;
		bStatus = Write_Line(file, strLine);
	}
	file.Close();
	return bStatus;
}

// Assigns a filename to the quiz, also sets the name
// of its log file.
void CFlashQuizDoc::Set_File_Name(LPCTSTR pszName)
{
	int i, j;
	CString strTemp1(pszName), strTemp2;

	if (pszName == NULL)
	{
		m_strFileName.Empty();
		m_strLogFileName.Empty();
		return;
	}
	m_strFileName = strTemp1;
	if (m_strFileName.IsEmpty())
	{
		m_strLogFileName.Empty();
		return;
	}
	i = m_strFileName.ReverseFind('.');
	j = m_strFileName.ReverseFind('\\');
	if ((i < 0) || ((j >= 0) && (i < j)))
	{
		m_strLogFileName.Format("%s.fql", m_strFileName);
	}
	else
	{
		m_strLogFileName = m_strFileName.Left(i + 1);
		m_strLogFileName += "fql";
	}
}

// Writes a "line" of encrypted text to the log file.
// Actually, the entire contents of the strLine argument
// are encrypted and written, without regard for its actual contents.
BOOL CFlashQuizDoc::Write_Line(CFile& file, CString& strLine)
{
	int		iDataLen;
	BYTE	*pData;
	BOOL	bStatus = TRUE;

	pData = theApp.Scramble(strLine);
	if (pData == NULL)
		return FALSE;
	iDataLen = strLine.GetLength();
	try
	{
		file.Write(&iDataLen, 4);
		file.Write(pData, iDataLen);
	}
	catch (CException *e)
	{
		e->Delete();
		bStatus = FALSE;
	}
	delete [] pData;
	return bStatus;
}

// Decrypts the current quiz's score log and copies it to the specified
// text file.
void CFlashQuizDoc::Export_Log(LPCTSTR strFileName, CWnd* pParent)
{
	int				iDataLen;
	BYTE			data[4096];
	CFile			fileIn,
					fileOut;
	CString			strLine;
	unsigned long	nFileSize;

	if (!fileIn.Open(m_strLogFileName, CFile::modeRead | CFile::shareExclusive, NULL))
	{
		strLine.Format("Could not open %s for input.", m_strLogFileName);
		pParent->MessageBox(strLine, "Error", MB_ICONINFORMATION);
		return;
	}
	if (!fileOut.Open(strFileName, CFile::modeCreate | CFile::modeWrite | CFile::shareExclusive))
	{
		strLine.Format("Could not replace output file %s", strFileName);
		pParent->MessageBox(strLine, "Error", MB_ICONINFORMATION);
		fileIn.Close();
		return;
	}
	fileIn.Read(data, 13);
	data[13] = '\0';
	if (strcmp((const char *) data, "FlashQuiz Log") != 0)
	{
		strLine.Format("Input file %s\nis either damaged or not a FlashQuiz Log", m_strLogFileName);
		pParent->MessageBox(strLine, "Error", MB_ICONINFORMATION);
		fileIn.Close();
		fileOut.Close();
		return;
	}
	nFileSize = fileIn.GetLength();
	do
	{
		try
		{
			fileIn.Read(&iDataLen, 4);
			fileIn.Read(data, iDataLen);
		}
		catch (CException *e)
		{
			e->Delete();
			strLine.Format("Input file %s\nis either damaged or not a FlashQuiz Log", m_strLogFileName);
			pParent->MessageBox(strLine, "Error", MB_ICONINFORMATION);
			break;
		}
		theApp.UnScramble(data, iDataLen, strLine);
		try
		{
			fileOut.Write(strLine, iDataLen);
		}
		catch (CException *e)
		{
			e->Delete();
			strLine.Format("Error writing to %s", strFileName);
			pParent->MessageBox(strLine, "Error", MB_ICONINFORMATION);
			break;
		}
	} while (fileIn.GetPosition() < nFileSize);
	fileIn.Close();
	fileOut.Close();
	return;
}

/////////////////////////////////////////
// Implementation of the CQuestion class

// Constructor
CQuestion::CQuestion()
{
	int i;

	m_strQuestion.Empty();
	m_strBitmapFile.Empty();
	m_intNumAnswers = 0;
	m_intScore = 1;
	m_intScoreDeduct = 0;
	m_intTime = 0;
	m_intTimeDeduct = 0;
	m_intActualScore = 0;
	m_bTimedOut = FALSE;
	m_bAllowMultiple = FALSE;
	m_bCustomFont = FALSE;
	m_pFont = NULL;
	for (i = 0; i < 5; i++)
	{
		m_strAnswers[i].Empty();
		m_bCorrect[i] = FALSE;
	}
}

// Destructor
CQuestion::~CQuestion()
{
	int i;

	for (i = 0; i < 5; i++)
	{
		m_strAnswers[i].Empty();
	}
	if (m_pFont != NULL)
	{
		delete m_pFont;
		m_pFont = NULL;
	}
}

// Sets or clears custom font.
// If passed pointer is NULL, removes custom font.
BOOL CQuestion::Set_Font(LOGFONT *pLogFont)
{
	if (pLogFont == NULL)
	{
		if (m_pFont != NULL)
		{
			delete m_pFont;
			m_pFont = NULL;
			m_bCustomFont = FALSE;
		}
		return TRUE;
	}
	if (m_pFont == NULL)
	{
		m_pFont = new LOGFONT;
		if (m_pFont == NULL)
			return FALSE;
	}
	*m_pFont = *pLogFont;
	m_bCustomFont = TRUE;
	return TRUE;
}
