// PwdDlg.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "stdafx.h"
#include "flashquiz.h"
#include "PwdDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFlashQuizApp theApp;
extern CFlashQuizDoc theDoc;

/////////////////////////////////////////////////////////////////////////////
// CPwdDlg dialog


CPwdDlg::CPwdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPwdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPwdDlg)
	m_strPwd1 = _T("");
	m_strPwd2 = _T("");
	m_strPwd3 = _T("");
	//}}AFX_DATA_INIT
}


void CPwdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPwdDlg)
	DDX_Control(pDX, IDC_lblPwd3, m_lblPwd3);
	DDX_Control(pDX, IDC_lblPwd2, m_lblPwd2);
	DDX_Control(pDX, IDC_txtPwd3, m_txtPwd3);
	DDX_Control(pDX, IDC_lblPrompt, m_lblPrompt);
	DDX_Control(pDX, IDC_txtPwd2, m_txtPwd2);
	DDX_Control(pDX, IDC_txtPwd1, m_txtPwd1);
	DDX_Control(pDX, IDC_lblPwd1, m_lblPwd1);
	DDX_Text(pDX, IDC_txtPwd1, m_strPwd1);
	DDX_Text(pDX, IDC_txtPwd2, m_strPwd2);
	DDX_Text(pDX, IDC_txtPwd3, m_strPwd3);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPwdDlg, CDialog)
	//{{AFX_MSG_MAP(CPwdDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPwdDlg message handlers

BOOL CPwdDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_txtPwd1.SetLimitText(32);
	m_txtPwd2.SetLimitText(32);
	m_txtPwd3.SetLimitText(32);
	switch (m_intMode)
	{
	case 0:		// Confirm existing password.
		m_lblPrompt.ShowWindow(SW_HIDE);
		m_lblPwd2.ShowWindow(SW_HIDE);
		m_lblPwd3.ShowWindow(SW_HIDE);
		m_txtPwd2.ShowWindow(SW_HIDE);
		m_txtPwd3.ShowWindow(SW_HIDE);
		m_lblPwd1.SetWindowText("&Enter password:");
		m_lblPwd1.ShowWindow(SW_SHOW);
		m_txtPwd1.ShowWindow(SW_SHOW);
		SetWindowText("Enter Password");
		break;
	case 1:		// Set initial password
		m_lblPwd1.ShowWindow(SW_HIDE);
		m_txtPwd1.ShowWindow(SW_HIDE);
		m_lblPrompt.ShowWindow(SW_SHOW);
		m_txtPwd2.SetFocus();
		SetWindowText("Choose Password");
		return FALSE;
	case 2:		// Change password.
		m_lblPrompt.ShowWindow(SW_HIDE);
		m_lblPwd1.ShowWindow(SW_SHOW);
		m_txtPwd1.ShowWindow(SW_SHOW);
		SetWindowText("Change Password");
	}
	return TRUE;
}

void CPwdDlg::OnOK() 
{
	static int iFailCount = 0;

	UpdateData(TRUE);
	Trim_Whitespace(m_strPwd1);
	Trim_Whitespace(m_strPwd2);
	Trim_Whitespace(m_strPwd3);
	UpdateData(FALSE);

	// If confirming or changing password,
	if (m_intMode == 0 || m_intMode == 2)
	{
		// Password supplied must match the document.
		if (m_strPwd1 != theDoc.m_strPassword)
		{
			MessageBox("Invalid password!", "FlashQuiz", MB_ICONINFORMATION);
			// If confirming password,
			if (m_intMode == 0)
			{
				// 3 strikes and you're out!
				++iFailCount;
				if (iFailCount == 3)
				{
					EndDialog(IDABORT);
				}
			}
			m_strPwd1.Empty();
			UpdateData(FALSE);
			m_txtPwd1.SetFocus();
			return;
		}
	}
	// If getting initial password or changing existing password:
	if (m_intMode == 1 || m_intMode == 2)
	{
		if (m_strPwd2.IsEmpty())
		{
			MessageBox("Password cannot be blank!", "Error", MB_ICONINFORMATION);
			m_txtPwd2.SetFocus();
			return;
		}
		// Both supplied passwords must match.
		if (m_strPwd2 != m_strPwd3)
		{
			MessageBox("Passwords don't match.", "Error", MB_ICONINFORMATION);
			m_strPwd2.Empty();
			m_strPwd3.Empty();
			UpdateData(FALSE);
			m_txtPwd2.SetFocus();
			return;
		}
	}
	if (m_intMode == 1 || m_intMode == 2)
	{
		if (theDoc.m_strPassword != m_strPwd2)
			theDoc.SetModifiedFlag(TRUE);
		theDoc.m_strPassword = m_strPwd2;
	}
	CDialog::OnOK();
}

void CPwdDlg::Trim_Whitespace(CString &strTarget)
{
	strTarget.TrimLeft();
	strTarget.TrimRight();
}
