// QEdit.cpp : implementation file
//
// FlashQuiz v1.0
// Copyright  2000 Ziff Davis Media, Inc.
// Written by Gregory A. Wolking.

#include "stdafx.h"
#include "FlashQuiz.h"
#include "MultChoice.h"
#include "QEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFlashQuizApp theApp;
extern CFlashQuizDoc theDoc;

/////////////////////////////////////////////////////////////////////////////
// CQEdit dialog


CQEdit::CQEdit(CWnd* pParent /*=NULL*/)
	: CDialog(CQEdit::IDD, pParent)
{
	int i;
	//{{AFX_DATA_INIT(CQEdit)
	m_bUseBitmap = FALSE;
	m_intScore = 1;
	m_intTimeLimit = 1;
	m_intReduceTime = 1;
	m_intReduceScore = 1;
	m_bTimeLimit = FALSE;
	m_bReduce = FALSE;
	m_strBitmap = _T("");
	m_bAllowMultiple = TRUE;
	m_bCustomFont = FALSE;
	//}}AFX_DATA_INIT
	m_pQuestion = NULL;
	for (i = 0; i < 5; i++)
	{
		m_bCorrect[i] = FALSE;
		m_strAnswer[i].Empty();
	}
}


void CQEdit::DoDataExchange(CDataExchange* pDX)
{
	int i;

	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQEdit)
	DDX_Control(pDX, IDC_cmdChangeFont, m_cmdChangeFont);
	DDX_Control(pDX, IDOK, m_cmdOK);
	DDX_Control(pDX, IDCANCEL, m_cmdCancel);
	DDX_Control(pDX, IDC_chkReduce, m_chkReduce);
	DDX_Control(pDX, IDC_txtReduceTime, m_txtReduceTime);
	DDX_Control(pDX, IDC_txtReduceScore, m_txtReduceScore);
	DDX_Control(pDX, IDC_txtTimeLimit, m_txtTimeLimit);
	DDX_Control(pDX, IDC_spnTime, m_spnTime);
	DDX_Control(pDX, IDC_spnScore, m_spnScore);
	DDX_Control(pDX, IDC_spnReduceTime, m_spnReduceTime);
	DDX_Control(pDX, IDC_spnReduceScore, m_spnReduceScore);
	DDX_Control(pDX, IDC_cmdBrowse, m_cmdBrowse);
	DDX_Control(pDX, IDC_chkBitmap, m_chkBitmap);
	DDX_Control(pDX, IDC_txtQuestion, m_txtQuestion);
	DDX_Control(pDX, IDC_txtBitmap, m_txtBitmap);
	DDX_Check(pDX, IDC_chkBitmap, m_bUseBitmap);
	DDX_Text(pDX, IDC_txtQuestion, m_strQuestion);
	DDX_Text(pDX, IDC_txtScore, m_intScore);
	DDX_Text(pDX, IDC_txtTimeLimit, m_intTimeLimit);
	DDX_Text(pDX, IDC_txtReduceTime, m_intReduceTime);
	DDX_Text(pDX, IDC_txtReduceScore, m_intReduceScore);
	DDX_Check(pDX, IDC_chkTimeLimit, m_bTimeLimit);
	DDX_Check(pDX, IDC_chkReduce, m_bReduce);
	DDX_Text(pDX, IDC_txtBitmap, m_strBitmap);
	DDX_Check(pDX, IDC_chkAllowMultiple, m_bAllowMultiple);
	DDX_Check(pDX, IDC_chkCustomFont, m_bCustomFont);
	//}}AFX_DATA_MAP
	// Class Wizard doesn't recognize arrays, so we have to
	// move these initializers outside the Class Wizard's reserved block.
	for (i = 0; i < 5; i++)
	{
		DDX_Control(pDX, (IDC_txtAnswer1 + i), m_txtAnswer[i]);
		DDX_Text(pDX, (IDC_txtAnswer1 + i), m_strAnswer[i]);
		DDX_Control(pDX, (IDC_lblAnswer1 + i), m_lblAnswer[i]);
		DDX_Control(pDX, (IDC_chkCorrect1 + i), m_chkCorrect[i]);
		DDX_Check(pDX, (IDC_chkCorrect1 + i), m_bCorrect[i]);
	}
}


BEGIN_MESSAGE_MAP(CQEdit, CDialog)
	//{{AFX_MSG_MAP(CQEdit)
	ON_BN_CLICKED(IDC_chkBitmap, OnchkBitmap)
	ON_BN_CLICKED(IDC_cmdBrowse, OncmdBrowse)
	ON_BN_CLICKED(IDC_chkTimeLimit, OnchkTimeLimit)
	ON_BN_CLICKED(IDC_chkReduce, OnchkReduce)
	ON_BN_CLICKED(IDC_cmdPreview, OncmdPreview)
	ON_EN_CHANGE(IDC_txtBitmap, OnChangetxtBitmap)
	ON_EN_CHANGE(IDC_txtQuestion, OnChangetxtQuestion)
	ON_BN_CLICKED(IDC_chkAllowMultiple, OnchkAllowMultiple)
	ON_BN_CLICKED(IDC_chkCustomFont, OnchkCustomFont)
	ON_BN_CLICKED(IDC_cmdChangeFont, OncmdChangeFont)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_chkCorrect1, IDC_chkCorrect5, OnchkCorrect)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQEdit message handlers

BOOL CQEdit::OnInitDialog() 
{
	int i;
	CString strTemp;
	CFont	*pFont;

	CDialog::OnInitDialog();
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	m_txtQuestion.SetLimitText(255);
	for (i = 0; i < 5; i++)
		m_txtAnswer[i].SetLimitText(128);
	m_spnTime.SetRange(1, 300);
	m_spnScore.SetRange(1, 50);
	m_spnReduceScore.SetRange(1, 10);
	m_spnReduceTime.SetRange(1, 300);
	if (m_bMode)
	{
		if (m_pQuestion != NULL)
		{
			for (i = 0; i < 5; i++)
			{
				m_bCorrect[i] = m_pQuestion->m_bCorrect[i];
				m_strAnswer[i] = m_pQuestion->m_strAnswers[i];
			}
			m_strQuestion = m_pQuestion->m_strQuestion;
			m_strBitmap = m_pQuestion->m_strBitmapFile;
			m_bUseBitmap = !m_strBitmap.IsEmpty();
			m_intScore = m_pQuestion->m_intScore;
			m_bAllowMultiple = m_pQuestion->m_bAllowMultiple;
			m_spnScore.SetPos(m_intScore);
		}
		strTemp.Format("Editing Question %u", m_intItem);
		SetWindowText(strTemp);
	}
	else
	{
		strTemp.Format("Adding Question %u", m_intItem);
		SetWindowText(strTemp);
		m_pQuestion = new CQuestion;
		if (m_pQuestion == NULL)
		{
			::MessageBox(NULL, "CQuestion allocation failed", "QEdit error", MB_ICONINFORMATION);
			EndDialog(IDCANCEL);
		}
		for (i = 0; i < 5; i++)
		{
			m_strAnswer[i].Empty();
			m_bCorrect[i] = FALSE;
		}
		m_strQuestion.Empty();
		m_strBitmap.Empty();
		m_bUseBitmap = FALSE;
		m_pQuestion->m_intScore = theDoc.m_intDefaultScore;
		m_pQuestion->m_intTime = theDoc.m_intDefaultQuestionTime;
		m_pQuestion->m_intTimeDeduct = theDoc.m_intDefaultTimeDeduct;
		m_pQuestion->m_intScoreDeduct = theDoc.m_intDefaultScoreDeduct;
		if (theDoc.m_bCustomFont)
			m_pQuestion->Set_Font(&theDoc.m_fontCustom);
		else
			m_pQuestion->Set_Font(NULL);
		m_cmdOK.SetWindowText("Add Question");
		m_cmdOK.EnableWindow(FALSE);
		m_cmdCancel.SetWindowText("Done");
	}
	m_bCustomFont = m_pQuestion->m_bCustomFont;
	if (m_bCustomFont)
	{
		m_fontCustom = *m_pQuestion->m_pFont;
	}
	else
	{
		pFont = GetFont();
		pFont->GetLogFont(&m_fontCustom);
	}
	m_cmdChangeFont.EnableWindow(m_bCustomFont);
	m_bAllowMultiple = m_pQuestion->m_bAllowMultiple;
	for (i = 0; i < 5; i++)
	{
		m_chkCorrect[i].SetButtonStyle(m_bAllowMultiple ? BS_AUTOCHECKBOX : BS_AUTORADIOBUTTON);
	}
	if (m_pQuestion->m_intTime == 0)
	{
		m_intTimeLimit = 1;
		m_bTimeLimit = FALSE;
	}
	else
	{
		m_intTimeLimit = m_pQuestion->m_intTime;
		m_bTimeLimit = TRUE;
	}
	m_spnTime.SetPos(m_intTimeLimit);
	if (m_pQuestion->m_intTimeDeduct == 0)
	{
		m_intReduceTime = 1;
		m_intReduceScore = 1;
		m_bReduce = FALSE;
	}
	else
	{
		m_intReduceTime = m_pQuestion->m_intTimeDeduct;
		m_intReduceScore = m_pQuestion->m_intScoreDeduct;
		m_bReduce = TRUE;
	}
	m_intScore = m_pQuestion->m_intScore;
	m_spnScore.SetPos(m_intScore);
	m_spnReduceTime.SetPos(m_intReduceTime);
	m_spnReduceScore.SetPos(m_intReduceScore);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	UpdateData(FALSE);
	Enable_Numerics();
	return TRUE;
}

void CQEdit::OnchkBitmap() 
{
	UpdateData(TRUE);
	m_cmdBrowse.EnableWindow(m_bUseBitmap);
	m_txtBitmap.EnableWindow(m_bUseBitmap);
	if (m_bUseBitmap)
		m_txtBitmap.SetFocus();
	Enable_Add_Button();
}

void CQEdit::OncmdBrowse() 
{
	CString strTemp;
	char	szBuffer[_MAX_PATH];

	GetCurrentDirectory(_MAX_PATH, szBuffer);
	CFileDialog dlg(TRUE, ".bmp", NULL, OFN_EXPLORER | OFN_FILEMUSTEXIST, "Windows Bitmaps (*.bmp)|*.bmp||", this);
	if (dlg.DoModal() == IDOK)
	{
		strTemp = dlg.GetPathName();
		m_txtBitmap.SetWindowText(strTemp);
	}
	else
	{
		UpdateData(TRUE);
		if (m_strBitmap.IsEmpty())
		{
			m_bUseBitmap = FALSE;
			m_txtBitmap.EnableWindow(FALSE);
			m_cmdBrowse.EnableWindow(FALSE);
			m_chkBitmap.SetCheck(0);
		}
	}
	SetCurrentDirectory(szBuffer);
}

void CQEdit::OnchkCorrect(UINT nID) 
{
	UINT nWhich = nID - IDC_chkCorrect1;
	ASSERT(nWhich < 5);
	m_bCorrect[nWhich] = m_chkCorrect[nWhich].GetCheck();
}

void CQEdit::OnCancel() 
{
	if (!m_bMode)
	{
		UpdateData(TRUE);
		if (Compare_Fields())
		{
			if (MessageBox("Quit without adding this question?", "FlashQuiz", MB_YESNO | MB_ICONQUESTION) != IDYES)
				return;
		}
		if (m_pQuestion != NULL)
		{
			delete m_pQuestion;
			m_pQuestion = NULL;
		}
	}
	CDialog::OnCancel();
}

void CQEdit::OnOK() 
{
	int		i;
	
	if (!Validate_Fields())
		return;
	if (Compare_Fields())
		theDoc.SetModifiedFlag(TRUE);
	m_pQuestion->m_strQuestion = m_strQuestion;
	for (i = 0; i < 5; i++)
	{
		m_pQuestion->m_strAnswers[i] = m_strAnswer[i];
		m_pQuestion->m_bCorrect[i] = m_bCorrect[i];
	}
	m_pQuestion->m_intScore = m_intScore;
	if (m_bTimeLimit)
		m_pQuestion->m_intTime = m_intTimeLimit;
	else
		m_pQuestion->m_intTime = 0;
	if (m_bTimeLimit && m_bReduce)
	{
		m_pQuestion->m_intScoreDeduct = m_intReduceScore;
		m_pQuestion->m_intTimeDeduct = m_intReduceTime;
	}
	else
	{
		m_pQuestion->m_intScoreDeduct = 0;
		m_pQuestion->m_intTimeDeduct = 0;
	}
	if (m_bUseBitmap)
		m_pQuestion->m_strBitmapFile = m_strBitmap;
	else
		m_pQuestion->m_strBitmapFile.Empty();
	m_pQuestion->m_bAllowMultiple = m_bAllowMultiple;
	if (m_bCustomFont)
		m_pQuestion->Set_Font(&m_fontCustom);
	else
		m_pQuestion->Set_Font(NULL);
	CDialog::OnOK();
}

void CQEdit::OnchkTimeLimit() 
{
	Enable_Numerics();
}

void CQEdit::OnchkReduce() 
{
	Enable_Numerics();
}

// Checks answer fields for gaps, compacts them if necessary.
// Returns TRUE if compaction was required, otherwise FALSE.
BOOL CQEdit::Compact_Fields()
{
	int		i, j;
	BOOL	bStatus, bPacked;
	CString strTemp;

	UpdateData(TRUE);					// Retrieve fields.
	for (i = 0; i < 5; i++)				// Trim leading & trailing spaces.
	{
		m_strAnswer[i].TrimRight();
		m_strAnswer[i].TrimLeft();
	}
	bStatus = FALSE;					// Default = no compaction.
	do
	{
		bPacked = FALSE;				// Reset flag.
		for (i = 0; i < 4; i++)			// For each field:
		{
			// If this field is blank and the next one is not:
			if (m_strAnswer[i].IsEmpty() && !m_strAnswer[i+1].IsEmpty())
			{
				bPacked = TRUE;				// Set flag.
				// Move remaining fields up to fill the gap.
				for (j = i; j < 4; j++)
				{
					m_strAnswer[j] = m_strAnswer[j + 1];
					m_bCorrect[j] = m_bCorrect[j + 1];
					bStatus = TRUE;
				}
				// Set last field to blank.
				m_strAnswer[4].Empty();
				m_bCorrect[4] = FALSE;
			}
		}
	} while (bPacked);		// Loop until no compaction is necessary.
	UpdateData(FALSE);		// Reload controls.
	return bStatus;			// Return status to caller.
}

// Compares dialog fields with the current question.
// Returns TRUE if any entries don't match.
// Called by OnOK() to determine whether or not the current question has
// actually been modified.
BOOL CQEdit::Compare_Fields()
{
	int		i;
	BYTE	*p1, *p2;

	if (m_strQuestion != m_pQuestion->m_strQuestion)
		return TRUE;
	if (m_bUseBitmap != (!m_pQuestion->m_strBitmapFile.IsEmpty()))
		return TRUE;
	if (m_bUseBitmap)
		if (m_strBitmap != m_pQuestion->m_strBitmapFile)
			return TRUE;
	for (i = 0; i < 5; i++)
	{
		if (m_strAnswer[i] != m_pQuestion->m_strAnswers[i])
			return TRUE;
		if (m_bCorrect[i] != m_pQuestion->m_bCorrect[i])
			return TRUE;
	}
	if ((int) m_intScore != m_pQuestion->m_intScore)
		return TRUE;
	if (m_bTimeLimit != (m_pQuestion->m_intTime != 0))
		return TRUE;
	if (m_bTimeLimit)
		if ((int) m_intTimeLimit != m_pQuestion->m_intTime)
			return TRUE;
	if (m_bReduce != (m_pQuestion->m_intTimeDeduct != 0))
		return TRUE;
	if (m_bReduce)
	{
		if ((int) m_intReduceScore != m_pQuestion->m_intScoreDeduct)
			return TRUE;
		if ((int) m_intReduceTime != m_pQuestion->m_intTimeDeduct)
			return TRUE;
	}
	if (m_bAllowMultiple != m_pQuestion->m_bAllowMultiple)
		return TRUE;
	if (m_bCustomFont != m_pQuestion->m_bCustomFont)
		return TRUE;
	if (m_bCustomFont)
	{
		p1 = (BYTE *) &m_fontCustom;
		p2 = (BYTE *) m_pQuestion->m_pFont;
		for (i = 0; i < sizeof(LOGFONT); i ++)
		{
			if (p1[i] != p2[i])
				return TRUE;
		}
	}
	return FALSE;
}

void CQEdit::OncmdPreview() 
{
	int			i;
	CMultChoice dlg;
	CQuestion	question;

	if (!Validate_Fields())
		return;

	theDoc.m_intTimeLeft = theDoc.m_intTimeLimit * 60;
	theDoc.m_intPossibleScore = 0;
	theDoc.m_intTotalScore = 0;
	question.m_strQuestion = m_strQuestion;
	question.m_bAllowMultiple = m_bAllowMultiple;
	if (m_bCustomFont)
		question.Set_Font(&m_fontCustom);
	for (i = 0; i < 5; i++)
	{
		question.m_strAnswers[i] = m_strAnswer[i];
		question.m_bCorrect[i] = m_bCorrect[i];
	}
	question.m_intScore = m_intScore;
	if (m_bTimeLimit)
		question.m_intTime = m_intTimeLimit;
	else
		question.m_intTime = 0;
	if (m_bTimeLimit && m_bReduce)
	{
		question.m_intScoreDeduct = m_intReduceScore;
		question.m_intTimeDeduct = m_intReduceTime;
	}
	else
	{
		question.m_intScoreDeduct = 0;
		question.m_intTimeDeduct = 0;
	}
	if (m_bUseBitmap)
		question.m_strBitmapFile = m_strBitmap;
	else
		question.m_strBitmapFile.Empty();
	dlg.m_pQuestion = &question;
	dlg.m_intQuestion = m_intItem;
	dlg.m_bPreviewMode = TRUE;
	dlg.DoModal();
}

BOOL CQEdit::Validate_Fields()
{
	int		i, iPos;
	BOOL	bScratch, bScratch2;
	BOOL	bResult;
	CString strTemp, strTemp2;

	UpdateData(TRUE);
	m_strQuestion.TrimLeft();
	m_strQuestion.TrimRight();
	if (m_strQuestion.IsEmpty() && !m_bUseBitmap)
	{
		MessageBox("You must provide either question text,\n"
					"an image file, or both.", "FlashQuiz", MB_ICONINFORMATION);
		return FALSE;
	}
	if (Compact_Fields())
	{
		MessageBox("You answers have been compacted to remove gaps.\n"
					"Please verify the results.", "FlashQuiz", MB_ICONINFORMATION);
		return FALSE;
	}
	iPos = 0;
	bScratch = bScratch2 = FALSE;
	for (i = 0; i < 5; i++)
	{
		bScratch = bScratch | m_bCorrect[i];
		if (!m_strAnswer[i].IsEmpty())
			++iPos;
		bScratch2 |= (m_strAnswer[i].IsEmpty() && m_bCorrect[i]);
	}
	if (!bScratch)
	{
		MessageBox("You must specify at least one correct answer.", "FlashQuiz", MB_ICONINFORMATION);
		return FALSE;
	}
	if (iPos < 2)
	{
		MessageBox("You must provide at least two answers.", "FlashQuiz", MB_ICONINFORMATION);
		return FALSE;
	}
	if (bScratch2)
	{
		MessageBox("Correct answer(s) cannot be blank.", "FlashQuiz", MB_ICONINFORMATION);
		return FALSE;
	}
	if (m_bUseBitmap)
	{
		if (theApp.Find_Image_File(m_strBitmap, strTemp))
		{
			bResult = theApp.Check_Bitmap_Header(strTemp);
			if (!bResult)
			{
				strTemp2.Format("%s is not a valid Windows bitmap.", strTemp);
				MessageBox(strTemp2, "FlashQuiz", MB_ICONINFORMATION);
			}
			return bResult;
		}
		else
		{
			MessageBox("Bitmap file does not exist, either in\n"
						"the specified directory or the current working directory.", "FlashQuiz", MB_ICONINFORMATION);
			return FALSE;
		}
	}
	return TRUE;
}

void CQEdit::Enable_Numerics()
{
	UpdateData(TRUE);
	BOOL bEnable = m_bTimeLimit;
	m_txtTimeLimit.EnableWindow(bEnable);
	m_spnTime.EnableWindow(bEnable);
	m_chkReduce.EnableWindow(bEnable);
	bEnable = m_bTimeLimit && m_bReduce;
	m_txtReduceTime.EnableWindow(bEnable);
	m_spnReduceTime.EnableWindow(bEnable);
	m_txtReduceScore.EnableWindow(bEnable);
	m_spnReduceScore.EnableWindow(bEnable);
}

void CQEdit::Enable_Add_Button()
{
	if (m_bMode)
		return;
	UpdateData(TRUE);
	m_cmdOK.EnableWindow(!m_strQuestion.IsEmpty() || (m_bUseBitmap && !m_strBitmap.IsEmpty()));
}

void CQEdit::OnChangetxtBitmap() 
{
	Enable_Add_Button();
}

void CQEdit::OnChangetxtQuestion() 
{
	Enable_Add_Button();
}

void CQEdit::OnchkAllowMultiple() 
{
	UpdateData(TRUE);
	if (m_bAllowMultiple)
		Set_Button_Styles(BS_AUTOCHECKBOX);
	else
		Set_Button_Styles(BS_AUTORADIOBUTTON);
}

void CQEdit::Set_Button_Styles(UINT nStyle)
{
	int i;
	BOOL	bFound = FALSE;

	for (i = 0; i < 5; i++)
	{
		m_chkCorrect[i].SetButtonStyle(nStyle, TRUE);
		if (nStyle == BS_AUTORADIOBUTTON)
		{
			if (bFound)
			{
				m_bCorrect[i] = FALSE;
			}
			else
			{
				if (m_bCorrect[i])
					bFound = TRUE;
			}
		}
	}
	if (nStyle == BS_AUTORADIOBUTTON)
		UpdateData(FALSE);
}

void CQEdit::OnchkCustomFont() 
{
	UpdateData(TRUE);	// Retrieve the setting.
	if (m_bCustomFont)		// If box was just checked,
	{
		if (Do_Choose_Font() != IDOK)	// Let the user choose the custom font.
		{
			m_bCustomFont = FALSE;			// If he canceled, clear the checkbox.
			UpdateData(FALSE);
		}
	}
	m_cmdChangeFont.EnableWindow(m_bCustomFont);
}

void CQEdit::OncmdChangeFont() 
{
	Do_Choose_Font();
}

int CQEdit::Do_Choose_Font()
{
	int			iResult;
	CFontDialog* pDlg;		// Create a common Font dialog object.
	LOGFONT		font;
	
	// Create font dialog with current font data.
	pDlg = new CFontDialog(&m_fontCustom);
	iResult = pDlg->DoModal();
	if (iResult == IDOK)
	{
		// Retrieve current font information.
		pDlg->GetCurrentFont(&font);
		// Copy to local storage.
		m_fontCustom = font;
	}
	delete pDlg;
	return iResult;
}
